//Simple program that blinking leds

#include "AT91SAM7S64.h"
#include "system.h"
#include "usart.h"
#include "common/lib_twi.h"
#include "smb380.h"

/* in Hz*/
#define TWI_BUS_CLOCK   400000 

#define SAM7P64_SPI_BASE           AT91C_BASE_SPI
#define SAM7P64_SPI_ID             AT91C_ID_SPI
#define SAM7P64__SPI_PINS           PINS_SPI
#define SAM7P64_NPCS_PIN           PIN_SPI_NPCS0



unsigned char old_value=0;
unsigned char reg[2];
char acc_value[6];
//TWI
signed short int accx;
signed short int accy;
signed short int accz;
//SPI 
unsigned int axis_x;
unsigned int axis_y;
unsigned int axis_z;
unsigned int last; 

//MAIN POINTERS
AT91PS_PIO    m_pPio   = AT91C_BASE_PIOA;
AT91PS_PMC    p_pPMC   = AT91C_BASE_PMC;
AT91PS_USART  p_pUSART = AT91C_BASE_US0;
AT91PS_PDC    p_pPDC   = AT91C_BASE_PDC_US0;
AT91PS_MC     p_pMC    = AT91C_BASE_MC;
AT91PS_AIC    p_pAic   = AT91C_BASE_AIC;

//AT91PS_SPI s_pSpi = AT91C_BASE_SPI;

//it's a simple delay
void Delay (unsigned long a) { while (--a!=0); }

int main()
{
  unsigned char ch;
  //Init frequency
  InitFrec();
  //Init leds
  InitPeriphery();
  InitUSART0();
  
  //TODO - enable user RESET!!!!!!!!
  
  write_str_USART0("MOD-SMB380 tested with SAM7-P64 board\n\r");
  write_str_USART0("Press S to test SPI interface to Accelerator\n\r");
  write_str_USART0("Press T to test TWI interface to Accelerator\n\r");
  while(1){
        ch=read_char_USART0();
        if  ((ch=='t')|| (ch=='T')){
                      AT91F_TWI_Open(TWI_BUS_CLOCK);    
                      //2.1)register 0x14h - 
                      old_value=my_acc_read(0x14);
                      reg[0]=0x14;
                      reg[1]=old_value & 0xE0;
                      acc_write(reg[0],reg[1]);//use my function instead I2C_MasterWrite (I2C_slave,reg,2);//for write command - 1 or 2 bytes are required
                      //2.2)register 15h
                      old_value=my_acc_read(0x15);
                      reg[0]=0x15;
                      reg[1]=0x41;//enable enable_adv_int
                      acc_write(reg[0],reg[1]);//use my function instead I2C_MasterWrite(I2C_slave,reg,2);//for write command - 1 or 2 bytes are required
                      //2.3) register 0x0Bh
                      reg[0]=0x0B;
                      reg[1]=0x40;//enable any_motion
                      acc_write(reg[0],reg[1]);
                      //Check out values from operational registers of Acc.	
                      old_value=my_acc_read(0x15);
                      old_value=my_acc_read(0x14);
                      old_value=my_acc_read(0x0F);
                      old_value=my_acc_read(0x0E);
                      old_value=my_acc_read(0x0D);
                      old_value=my_acc_read(0x0C);
                      old_value=my_acc_read(0x0B);
                      old_value=my_acc_read(0x0A); 
                      //3)read accelerator values - 0x02h - 0x06h
                      reg[0]=0x02;//data register address
                      while(1){
                       acc_read(reg[0]);//	use my function instead I2C_Transfer (I2C_slave,reg,6,WRITETHENREAD,1);
                       Convert2Int();
                       Convert2LCD();
                       Delay(900000);
                      }
          }else if((ch=='s')|| (ch=='S')){                      	
                      initSPI ();
                    //2.1)register 0x14h - 
                    old_value=acc_spi_read(0x14);
                    reg[0]=0x14;
                    reg[1]=(old_value & 0xE0);//|0x10;
                    acc_spi_write(reg[0],reg[1]);
                    //2.2)register 15h
                    old_value=acc_spi_read(0x15);
                    reg[0]=0x15;
                    reg[1]=0xC1;//enable enable_adv_int
                    acc_spi_write(reg[0],reg[1]);
                    //2.3) register 0x0Bh
                    reg[0]=0x0B;
                    reg[1]=0x40;//enable any_motion
                    acc_spi_write(reg[0],reg[1]);
                    //Check out values from operational registers of Acc.	
                    old_value=acc_spi_read(0x15);
                    old_value=acc_spi_read(0x14);
                    old_value=acc_spi_read(0x0F);
                    old_value=acc_spi_read(0x0E);
                    old_value=acc_spi_read(0x0D);
                    old_value=acc_spi_read(0x0C);
                    old_value=acc_spi_read(0x0B);
                    old_value=acc_spi_read(0x0A); 
                    // loop forever
                  while(1)
                  {
                  axis_acc_spi_read(0x02);
                  Convert2LCD();
                  Delay(900000);
                  }
          }
  }
}

