#include "AT91SAM7S64.h"
#define __inline inline
#include "lib_AT91SAM7S64.h"

#include "system.h"
#include "usart.h"
#include "common/lib_twi.h"
#include "smb380.h"


extern char acc_value[6];
extern signed short int accx;
extern signed short int accy;
extern signed short int accz;
extern unsigned int axis_x;
extern unsigned int axis_y;
extern unsigned int axis_z;
extern unsigned int last; 
//////////////////////////////////////////////////////////////////////////////////////////
//_____________FUNCTIONS___________________________________________________________

/*********************************************************************************
Write to accelerometer register
**********************************************************************************/
/*
numreg - internal I2C slave address 
ConfigRegValue - data to be written
*/
  int acc_write(const char numreg,char ConfigRegValue){

        /* Send the Config. reg. */
        AT91F_TWI_WriteSingleIadr(AT91C_BASE_TWI,
                            I2C_Slave,
                            (char)numreg,
                            AT91C_TWI_IADRSZ_1_BYTE,
                            &ConfigRegValue);

  return (1);
  }
//////////////////////////////////////////////////////////////////////////////////
char my_acc_read(const unsigned char numreg){
  char  Data2Read;
  
  AT91F_TWI_ReadSingleIadr(AT91C_BASE_TWI,
                      I2C_Slave,
                      numreg,
                      AT91C_TWI_IADRSZ_1_BYTE,
                      &Data2Read);

  return (Data2Read);
		
}

////////////////////////////////////////////////////////////////////////////////////////////

/*****************************************************************************
read accelerometer register
*****************************************************************************/
void acc_read(const unsigned char numreg){
  
AT91F_TWI_ReadMultipleIadr(AT91C_BASE_TWI,
                      I2C_Slave,
                      6,
                      numreg,
                      AT91C_TWI_IADRSZ_1_BYTE,
                      acc_value);
  
}

////////////////////////////////////////////////////////////////////////////////////////////
void initSPI (void)
{
    /* Configure SPI PIOs */
//  my try  AT91F_SPI_CfgPIO ();
  AT91C_BASE_PIOA->PIO_PDR = BIT12 | BIT13 | BIT14;
  AT91C_BASE_PIOA->PIO_ASR = BIT12 | BIT13 | BIT14;
  AT91C_BASE_PIOA->PIO_BSR = 0;
  
  AT91C_BASE_PIOA->PIO_SODR = BIT31;

  AT91C_BASE_PIOA->PIO_OER = BIT31;

  AT91C_BASE_PIOA->PIO_PER = BIT31;

  
  AT91C_BASE_PMC->PMC_PCER = 1 << AT91C_ID_SPI;
  AT91C_BASE_SPI->SPI_CR      = 0x80;              //SPI Sowtware reset
  AT91C_BASE_SPI->SPI_CR      = 0x02;              //SPI Disable,
  
  
  AT91C_BASE_SPI->SPI_MR      = 0xD0011;          //Master mode, fixed select, disable decoder, FDIV=0 (MCK), PCS=1110

  AT91C_BASE_SPI->SPI_CSR[1]  = 0x4A81;           //!!!!16bit, CPOL=1, ClockPhase=0, SCLK = 200kHz,CSAAT=1

  /****  Fixed mode ****/

  AT91C_BASE_SPI->SPI_CR      = 0x01;              //SPI Enable
  
//  AT91C_BASE_PDC_SPI->PDC_PTCR = AT91C_PDC_TXTEN | AT91C_PDC_RXTEN;

 AT91C_BASE_SPI->SPI_PTCR = AT91C_PDC_TXTEN | AT91C_PDC_RXTEN;
  
    /* Configure PMC by enabling SPI clock */
  /*my try  AT91F_SPI_CfgPMC ();

    // Reset the SPI 
     AT91C_BASE_SPI->SPI_CR = AT91C_SPI_SWRST;

    // Configure SPI master mode - CPOL and CPHA 
      AT91F_SPI_CfgMode (
            AT91C_BASE_SPI,
	    0xD0011);
      //s_pSpi->SPI_MR      = 0xE0011;          //Master mode, fixed select, disable decoder, FDIV=0 (MCK), PCS=1110


  
      // configure SPI clock      
      AT91F_SPI_CfgCs (
	AT91C_BASE_SPI,
	0,     // SPI cs number (0 to 3)
 	0x4A01);
  //  s_pSpi->SPI_CSR[0]  = 0x4A01;           //8bit, CPOL=1, ClockPhase=0, SCLK = 200kHz????????
  AT91C_BASE_SPI->SPI_CSR[0]  = 0x4A01;
  
    //Enable SPI 
    //AT91C_BASE_SPI->SPI_CR = AT91C_SPI_SPIEN;
    AT91F_SPI_Enable(AT91C_BASE_SPI); */
}

#define	CS_HIGH()	AT91C_BASE_PIOA->PIO_SODR = BIT31
#define	CS_LOW()	AT91C_BASE_PIOA->PIO_CODR = BIT31

unsigned char acc_spi_read(const unsigned char numreg){
        unsigned int spib; 
//        unsigned int tmp=0;
        
	CS_LOW();
        // Send data
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);    
    AT91C_BASE_SPI->SPI_TDR = ( ((unsigned int)(numreg | 0x80)<<8)| 0xFF );// data;| SPI_PCS(npcs);
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);
    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
    spib = ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // data received, but discard
        
/* this is for 8bit transffered         
	while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);      // Wait for the transfer to complete
	AT91C_BASE_SPI->SPI_TDR = (unsigned int) (numreg | 0x80);    // Send the dataSSP1BUF=(unsigned char)(reg[0] | 0x80 ) 	;
       while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
        spib = ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // data received, but idscard
        
        while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);      // Wait for the transfer to complete
      	AT91C_BASE_SPI->SPI_TDR = (unsigned int) (0xFFFF);        
       while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
       spib = ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // Get the data received */
       CS_HIGH();	
        return spib;
}
/////////////////////////////////////////////////////////////////////////////////////////

unsigned char acc_spi_write(const unsigned char numreg, const unsigned char data){
	
  unsigned int spib;
   unsigned short tmp=0;
   
    CS_LOW();
    tmp =(unsigned int)(((numreg & 0xFF7F)<<8) | data);   
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
    AT91C_BASE_SPI->SPI_TDR = (unsigned int)tmp;    // Send the data
    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);      // Wait for the transfer to complete

    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
    spib = ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // data received, but idscard
/*for 8bit transfers
   tmp =(unsigned int)(numreg & 0xFF7F);    
    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);      // Wait until the character can be sent
    AT91C_BASE_SPI->SPI_TDR = (unsigned int) (data & 0xFFFF) ;    // Send the data //spib = ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // Get the data received
*/
    CS_HIGH();
    return(1);
    }

/////////////////////////////////////////////////////////////////////////////////////////
unsigned char axis_acc_spi_read(const unsigned char numreg){

        unsigned int tmp=0;
     
        
    CS_LOW();
    // Send data and read 
      //first byte read-out is dummy data, second is X-axis LSB
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
    AT91C_BASE_SPI->SPI_TDR = ( ((unsigned int)(numreg | 0x80)<<8)| 0xFF );// data;| SPI_PCS(npcs);
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);
    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
    axis_x = ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // data received, but discard
     //first byte read-out is X-axis MSB, second is Y-axis LSB    
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
    AT91C_BASE_SPI->SPI_TDR = 0xFFFF;// data;| SPI_PCS(npcs);
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);
    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
    axis_y= ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // data received, but discard
     //first byte read-out is Y-axis MSB, second is Z-axis LSB    
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
    AT91C_BASE_SPI->SPI_TDR = 0xFFFF;// data;| SPI_PCS(npcs);
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);
    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
    axis_z= ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // data received, but discard
     //first byte read-out is Z-axis MSB, second is temperature
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
    AT91C_BASE_SPI->SPI_TDR = 0xFFFF;// data;| SPI_PCS(npcs);
    while ((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_TDRE) == 0);
    while((AT91C_BASE_SPI->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
    last= ((AT91C_BASE_SPI->SPI_RDR) & 0xFFFF);                // data received, but discard

    // Get the data received */
    CS_HIGH();	
       
      
     tmp=(axis_x & 0x00FF) >>6;//=0;
     accx= (unsigned int)(((axis_y & 0xFF00) >>8)<<2) | tmp;

    
     tmp=(axis_y & 0x00FF) >>6;
     accy= (unsigned int)(((axis_z & 0xFF00) >>8) <<2)| tmp;

     tmp=(axis_z & 0x00FF) >>6;
     accz= (unsigned int)(((last & 0xFF00) >>8) <<2)| tmp;
     
        return 1;
}

////////////////////////////////////////////////////////////////////////////////////////////


void Convert2Int(void){
 
 unsigned char tmp=0;
 char newx=0;
 char newy=0;
 char newz=0;
 
newx=acc_value[0] & 0x01;	//new data received
tmp=acc_value[0] >>6;
accx= (signed short)(acc_value[1]<<2) | tmp;

newy=acc_value[2] & 0x01;	//new data received
tmp=acc_value[2] >>6;
accy= (signed short)(acc_value[3]<<2) | tmp;

newz=acc_value[4] & 0x01;	//new data received
tmp=acc_value[4] >>6;
accz= (signed short)(acc_value[5]<<2) | tmp;
  
}


//write_char_USART1(dec+48);
//write_char_USART1(edi+48);
////////////////////////////////////////////////////////////////////////////////
void Convert2LCD(void){
unsigned int sym=0;
        write_str_USART0("X=");
	if((accx / 1000)>0)
				{
					sym=accx / 1000;
					write_char_USART0(sym+48);//digitx[0]
				}
				else write_char_USART0('0');//digitx[0]
				
				if ((accx / 100)>0)
				{ 
					sym=accx / 100;
					accx=accx-sym*100;
					if (sym>9)
						sym=sym-10;
				  	write_char_USART0(sym +'0');//digitx[1]=
			
				}
			
				if ((accx / 10)>0)
				{ 
					sym=accx / 10;
					accx=accx-sym*10;
					if (sym>9)
						sym=sym-10;
				  	write_char_USART0(sym+'0');//digitx[2]=
					write_char_USART0(accx+'0');//digitx[3]=
				}
				else {
					sym=accx % 10;
					write_char_USART0('0');//digitx[2]=
					write_char_USART0(sym+'0');//digitx[3]=
				}
	
			        write_str_USART0("\n\r");
				write_str_USART0("Y=");
				if((accy / 1000)>0)
				{
					sym=accy / 1000;
					write_char_USART0(sym+'0');//digity[0]=
				}
					else write_char_USART0('0');//digity[0]=

				if ((accy / 100)>0)
				{ 
					sym=accy / 100;
					accy=accy-sym*100;
					if (sym>9)
						sym=sym-10;
				  	write_char_USART0(sym+'0');//digity[1]=
			
				}
			
				if ((accy / 10)>0)
				{ 
					sym=accy / 10;
					accy=accy-sym*10;
					if (sym>9)
						sym=sym-10;
				  	write_char_USART0(sym+'0');//digity[2]=
					write_char_USART0(accy+'0');//digity[3]=
				}
				else {
					sym=accy % 10;
					write_char_USART0('0');//digity[2]=
					write_char_USART0(sym+'0');//digity[3]=
				}
			
                                write_str_USART0("\n\r");
				write_str_USART0("Z=");

				if((accz /1000)>0)
				{
					sym=accz / 1000;
					write_char_USART0(sym+'0');//digitz[0]=
				}
					else write_char_USART0('0');//digitz[0]=
				if ((accz / 100)>0)
				{ 
					sym=accz / 100;
					accz=accz-sym*100;
					if (sym>9)
						sym=sym-10;
				  	write_char_USART0(sym+'0');//digitz[1]=
			
				}
				if ((accz / 10)>0)
				{ 
					sym=accz / 10;
					accz=accz-sym*10;
					if (sym>9)
						sym=sym-10;
				  	write_char_USART0(sym+'0');//digitz[2]=
					write_char_USART0(accz+'0');//digitz[3]=
				 }
				else {
					sym=accz % 10;
					write_char_USART0('0');//digitz[2]=
					write_char_USART0(sym+'0');//digitz[3]=
				} 
                                write_str_USART0("\n\r");
	}
